Subject: (ngtrans) http://www.ietf.org/internet-drafts/draft-ietf-ngtrans-shipworm-03.txt

From: "Mohit Talwar" <[email-masked]>
Date: Mon, 19 Nov 2001 09:30:56 -0800

Hullo Folks,

I have the following issues with draft-ietf-ngtrans-shipworm-03.txt.

(A) The following discrepencies between the shipworm qualification
protocol and
the corresponding neighbor discovery requirements should be resolved by
correcting the draft to make it consistent with 2461.  I believe these
changes
could make a shipworm implementation quite a bit simpler. 

	1. Router Advertisements (IPv6 Source Address):

	[Shipworm] 4.2.1   Qualification procedure

	The source address of the Router Advertisement is the Shipworm
IPv6
	address of the Shipworm server. This address must be built using
an
	IPv4 unicast address of the server, and a port number at which
the
	server is waiting for packets.

	[2461] 6.1.2.  Validation of Router Advertisement Messages

	      - IP Source Address is a link-local address.  Routers must
use
	        their link-local address as the source for Router
Advertisement
	        and Redirect messages so that hosts can uniquely
identify
	        routers.

	2. Router Solicitations (IPv6 Destination Address)

	[Shipworm] 4.2.1   Qualification procedure

	it as the IPv6 source of the message; the IPv6 destination of
the RS
	is the Shipworm IPv6 anycast address; the packet will be sent
over

	[2461] 6.3.7.  Sending Router Solicitations

	   A host sends Router Solicitations to the All-Routers
multicast
	   address.  The IP source address is set to either one of the

	3. Values of Constants

	[Shipworm] 4.2.1   Qualification procedure

	In the starting state, the client waits for a router
advertisement
	from the Shipworm server. If no response comes within a
time-out,
	the client should repeat the start action, by resending the
Router
	Solicit packet. If no response has arrived after N=4
repetitions,
	the client concludes that it cannot use UDP, and that the
Shipworm
	service is not available; the status is set to "Off-line."

	[2461] 6.3.7.  Sending Router Solicitations

	   routers or learn prefixes.  To obtain Router Advertisements
quickly,
	   a host SHOULD transmit up to MAX_RTR_SOLICITATIONS Router
	   Solicitation messages each separated by at least
	   RTR_SOLICITATION_INTERVAL seconds.  Router Solicitations may
be sent

	            MAX_RTR_SOLICITATIONS             3 transmissions
RTR_SOLICITATION_INTERVAL         4 seconds

(B) [4.2.5]
	The client MUST NOT send a bubble if the last transmission date
and
	time is less than 10 seconds before the current date and time,
or if
	the number of transmitted bubbles is larger than 4 and the last
	reception date and time is less than 300 seconds before the
current
	date and time. In the other cases, the client MAY proceed with
the
	transmission of the bubble, which MUST be composed as specified
in

I am afraid that this paragraph is not very clear.  Is it the intention
that we
send bubbles at a rate of once every 10 seconds to peer that are
tunneling to
us directly, and at a rate of once every 5 minutes to those who are not?
Why
is there a threshhold of 4? 

(C)	- [5.3] Shipworm client behind a type 3 [4] NAT should not
bother sending
	- [5.3] when we suspect that the sending of the bubbles is
useless. In a
	type 3 [4] NAT we will send at most four bubbles to a
destination, and
	then we will observe a silence period of 300 seconds.

If I understand their working right, type 4 NATs are the problem case,
not type
3.  Also, the way section 4.2.5 describes it, it would result in (300 -
30)/10
= 27 bubbles to the destination, and no more bubbles hence.  The bound
of 4
seems to play no role (since we start off with the reception time set to
30
seconds before the current time). 

(D) Typos

- [4.2] to use this procedure or not depends on the delay since the last
                                           ^
 
- [4.2.1] UDP from the service port to the Shipworm IPv4 anycast address
and
                                                    ^^^^

- [4.2.1] destination address is equal to the random link local address
picked
used in the router solicitation, and that it contains exactly one
^^^^

- [4.2.2] with the Shipworm server" to the current data and time.
                                                   ^^^^
   
- [4.2.2] setting the last reception date do the current date and time,
the
                                          ^^

- [4.2.3] If there is an entry for this address and port pair in the
list of
recent Shipworm peers, and if the [last reception] date and time
associated with that
                                  ^^^^^^^^^^^^^^^^
list entry is less that 30 seconds from the current time the packet
                   ^^^^

- [4.3.2] and Shipworm Port. Before sending the packet, the Shipworm
relay [server]
 
^^^^^

Thanx,
Mohit.